$columns = 12
$offset = 30px
$offset_one_side = ($offset / 2)
$atom = (100% / $columns)

$break_lg = 1100px
$break_md = 960px
$break_sm = 780px
$break_xs = 560px

reset()
    body,div,dl,dt,dd,ul,li,h1,h2,h3,h4,h5,h6,pre,code,form,fieldset,input,textarea,p,blockquote,th,td
        margin 0
        padding 0
    
    table
        border-collapse collapse
        border-spacing 0
    
    fieldset,img,abbr
        border 0
    
    address,caption,cite,code,dfn,em,strong,th,var
        font-style normal
        font-weight normal
    
    ul li
        list-style none
    
    caption,th
        text-align left
    
    h1,h2,h3,h4,h5,h6
        font-size 100%
        font-weight normal
    
    sup
        vertical-align text-top
    
    sub
        vertical-align text-bottom
    
    input,textarea,select
        font-family inherit
        font-size inherit
        font-weight inherit
    
    legend
        color #000
    
    article,aside,details,figcaption,figure,footer,header,hgroup,menu,nav,section,main
        display block
    
    img
        max-width 100%
        height auto
    


wrapper()
    max-width 1200px
    padding-left 30px
    padding-right 30px
    margin 0 auto

    @media screen and (max-width: $break_lg)
        padding-left 30px
        padding-right 30px
    

    @media screen and (max-width: $break_md)
        padding-left 15px
        padding-right 15px
    

    @media screen and (max-width: $break_sm)
        padding-left 15px
        padding-right 15px
    

    @media screen and (max-width: $break_xs)
        padding-left 15px
        padding-right 15px
    

row-flex()
    display flex
    flex-wrap wrap
    margin-left ($offset_one_side * -1)
    margin-right ($offset_one_side * -1)

row-float()
    margin-left ($offset_one_side * -1)
    margin-right ($offset_one_side * -1)
    clearfix()

col()
    box-sizing border-box
    margin-left $offset_one_side
    margin-right $offset_one_side
    word-wrap break-word

col-float()
    float left

col-padding()
    padding-left $offset_one_side
    padding-right $offset_one_side
    word-wrap break-word

size($n)
    $value = $atom * $n
    width "calc(%s - %s)" % ($value $offset)

col-1()
    size(1)

col-2()
    size(2)

col-3()
    size(3)

col-4()
    size(4)

col-5()
    size(5)

col-6()
    size(6)

col-7()
    size(7)

col-8()
    size(8)

col-9()
    size(9)

col-10()
    size(10)

col-11()
    size(11)

col-12()
    size(12)

offset($n)
    $value = $atom * $n
    margin-left "calc(%s + %s)" % ($value $offset_one_side)
    margin-right "calc(%s + %s)" % ($value $offset_one_side)

offset-left($n)
    $value = $atom * $n
    margin-left "calc(%s + %s)" % ($value $offset_one_side)

offset-right($n)
    $value = $atom * $n
    margin-right "calc(%s + %s)" % ($value $offset_one_side)

offset-padding($n)
    $value = $atom * $n
    padding-left "calc(%s + %s)" % ($value $offset_one_side)
    padding-right "calc(%s + %s)" % ($value $offset_one_side)

offset-left-padding($n)
    $value = $atom * $n
    padding-left "calc(%s + %s)" % ($value $offset_one_side)

offset-right-padding($n)
    $value = $atom * $n
    padding-right "calc(%s + %s)" % ($value $offset_one_side)

justify-content($value)
    justify-content $value

align-items($value)
    align-items $value

align-content($value)
    align-content $value

align-self($value)
    align-self $value

order($value)
    order $value

flex($value)
    flex $value

flex-grow($value)
    flex-grow $value

flex-shrink($value)
    flex-shrink $value

flex-basis($value)
    flex-basis $value

flex-direction($value)
    flex-direction $value

flex-wrap($value)
    flex-wrap $value

flex-flow($value)
    flex-flow $value

float($value)
    float $value

size-lg($n)
    @media screen and (max-width: $break_lg)
        $value = $atom * $n
        width "calc(%s - %s)" % ($value $offset)
    

col-lg-1()
    size-lg(1)

col-lg-2()
    size-lg(2)

col-lg-3()
    size-lg(3)

col-lg-4()
    size-lg(4)

col-lg-5()
    size-lg(5)

col-lg-6()
    size-lg(6)

col-lg-7()
    size-lg(7)

col-lg-8()
    size-lg(8)

col-lg-9()
    size-lg(9)

col-lg-10()
    size-lg(10)

col-lg-11()
    size-lg(11)

col-lg-12()
    size-lg(12)

offset-lg($n)
    @media screen and (max-width: $break_lg)
        $value = $atom * $n
        margin-left "calc(%s + %s)" % ($value $offset_one_side)
        margin-right "calc(%s + %s)" % ($value $offset_one_side)
    

offset-left-lg($n)
    @media screen and (max-width: $break_lg)
        $value = $atom * $n
        margin-left "calc(%s + %s)" % ($value $offset_one_side)
    

offset-right-lg($n)
    @media screen and (max-width: $break_lg)
        $value = $atom * $n
        margin-right "calc(%s + %s)" % ($value $offset_one_side)
    

offset-padding-lg($n)
    @media screen and (max-width: $break_lg)
        $value = $atom * $n
        padding-left "calc(%s + %s)" % ($value $offset_one_side)
        padding-right "calc(%s + %s)" % ($value $offset_one_side)
    

offset-left-padding-lg($n)
    @media screen and (max-width: $break_lg)
        $value = $atom * $n
        padding-left "calc(%s + %s)" % ($value $offset_one_side)
    

offset-right-padding-lg($n)
    @media screen and (max-width: $break_lg)
        $value = $atom * $n
        padding-right "calc(%s + %s)" % ($value $offset_one_side)
    

justify-content-lg($value)
    @media screen and (max-width: $break_lg)
        justify-content $value
    

align-items-lg($value)
    @media screen and (max-width: $break_lg)
        align-items $value
    

align-content-lg($value)
    @media screen and (max-width: $break_lg)
        align-content $value
    

align-self-lg($value)
    @media screen and (max-width: $break_lg)
        align-self $value
    

order-lg($value)
    @media screen and (max-width: $break_lg)
        order $value
    

flex-lg($value)
    @media screen and (max-width: $break_lg)
        flex $value
    

flex-grow-lg($value)
    @media screen and (max-width: $break_lg)
        flex-grow $value
    

flex-shrink-lg($value)
    @media screen and (max-width: $break_lg)
        flex-shrink $value
    

flex-basis-lg($value)
    @media screen and (max-width: $break_lg)
        flex-basis $value
    

flex-direction-lg($value)
    @media screen and (max-width: $break_lg)
        flex-direction $value
    

flex-wrap-lg($value)
    @media screen and (max-width: $break_lg)
        flex-wrap $value
    

flex-flow-lg($value)
    @media screen and (max-width: $break_lg)
        flex-flow $value
    

float-lg($value)
    @media screen and (max-width: $break_lg)
        float $value
    

lg($name, $value)
    @media screen and (max-width: $break_lg)
        {$name} $value
    

lg-block(content)
    @media screen and (max-width: $break_lg)
        {content}
    

size-md($n)
    @media screen and (max-width: $break_md)
        $value = $atom * $n
        width "calc(%s - %s)" % ($value $offset)
    

col-md-1()
    size-md(1)

col-md-2()
    size-md(2)

col-md-3()
    size-md(3)

col-md-4()
    size-md(4)

col-md-5()
    size-md(5)

col-md-6()
    size-md(6)

col-md-7()
    size-md(7)

col-md-8()
    size-md(8)

col-md-9()
    size-md(9)

col-md-10()
    size-md(10)

col-md-11()
    size-md(11)

col-md-12()
    size-md(12)

offset-md($n)
    @media screen and (max-width: $break_md)
        $value = $atom * $n
        margin-left "calc(%s + %s)" % ($value $offset_one_side)
        margin-right "calc(%s + %s)" % ($value $offset_one_side)
    

offset-left-md($n)
    @media screen and (max-width: $break_md)
        $value = $atom * $n
        margin-left "calc(%s + %s)" % ($value $offset_one_side)
    

offset-right-md($n)
    @media screen and (max-width: $break_md)
        $value = $atom * $n
        margin-right "calc(%s + %s)" % ($value $offset_one_side)
    

offset-padding-md($n)
    @media screen and (max-width: $break_md)
        $value = $atom * $n
        padding-left "calc(%s + %s)" % ($value $offset_one_side)
        padding-right "calc(%s + %s)" % ($value $offset_one_side)
    

offset-left-padding-md($n)
    @media screen and (max-width: $break_md)
        $value = $atom * $n
        padding-left "calc(%s + %s)" % ($value $offset_one_side)
    

offset-right-padding-md($n)
    @media screen and (max-width: $break_md)
        $value = $atom * $n
        padding-right "calc(%s + %s)" % ($value $offset_one_side)
    

justify-content-md($value)
    @media screen and (max-width: $break_md)
        justify-content $value
    

align-items-md($value)
    @media screen and (max-width: $break_md)
        align-items $value
    

align-content-md($value)
    @media screen and (max-width: $break_md)
        align-content $value
    

align-self-md($value)
    @media screen and (max-width: $break_md)
        align-self $value
    

order-md($value)
    @media screen and (max-width: $break_md)
        order $value
    

flex-md($value)
    @media screen and (max-width: $break_md)
        flex $value
    

flex-grow-md($value)
    @media screen and (max-width: $break_md)
        flex-grow $value
    

flex-shrink-md($value)
    @media screen and (max-width: $break_md)
        flex-shrink $value
    

flex-basis-md($value)
    @media screen and (max-width: $break_md)
        flex-basis $value
    

flex-direction-md($value)
    @media screen and (max-width: $break_md)
        flex-direction $value
    

flex-wrap-md($value)
    @media screen and (max-width: $break_md)
        flex-wrap $value
    

flex-flow-md($value)
    @media screen and (max-width: $break_md)
        flex-flow $value
    

float-md($value)
    @media screen and (max-width: $break_md)
        float $value
    

md($name, $value)
    @media screen and (max-width: $break_md)
        {$name} $value
    

md-block(content)
    @media screen and (max-width: $break_md)
        {content}
    

size-sm($n)
    @media screen and (max-width: $break_sm)
        $value = $atom * $n
        width "calc(%s - %s)" % ($value $offset)
    

col-sm-1()
    size-sm(1)

col-sm-2()
    size-sm(2)

col-sm-3()
    size-sm(3)

col-sm-4()
    size-sm(4)

col-sm-5()
    size-sm(5)

col-sm-6()
    size-sm(6)

col-sm-7()
    size-sm(7)

col-sm-8()
    size-sm(8)

col-sm-9()
    size-sm(9)

col-sm-10()
    size-sm(10)

col-sm-11()
    size-sm(11)

col-sm-12()
    size-sm(12)

offset-sm($n)
    @media screen and (max-width: $break_sm)
        $value = $atom * $n
        margin-left "calc(%s + %s)" % ($value $offset_one_side)
        margin-right "calc(%s + %s)" % ($value $offset_one_side)
    

offset-left-sm($n)
    @media screen and (max-width: $break_sm)
        $value = $atom * $n
        margin-left "calc(%s + %s)" % ($value $offset_one_side)
    

offset-right-sm($n)
    @media screen and (max-width: $break_sm)
        $value = $atom * $n
        margin-right "calc(%s + %s)" % ($value $offset_one_side)
    

offset-padding-sm($n)
    @media screen and (max-width: $break_sm)
        $value = $atom * $n
        padding-left "calc(%s + %s)" % ($value $offset_one_side)
        padding-right "calc(%s + %s)" % ($value $offset_one_side)
    

offset-left-padding-sm($n)
    @media screen and (max-width: $break_sm)
        $value = $atom * $n
        padding-left "calc(%s + %s)" % ($value $offset_one_side)
    

offset-right-padding-sm($n)
    @media screen and (max-width: $break_sm)
        $value = $atom * $n
        padding-right "calc(%s + %s)" % ($value $offset_one_side)
    

justify-content-sm($value)
    @media screen and (max-width: $break_sm)
        justify-content $value
    

align-items-sm($value)
    @media screen and (max-width: $break_sm)
        align-items $value
    

align-content-sm($value)
    @media screen and (max-width: $break_sm)
        align-content $value
    

align-self-sm($value)
    @media screen and (max-width: $break_sm)
        align-self $value
    

order-sm($value)
    @media screen and (max-width: $break_sm)
        order $value
    

flex-sm($value)
    @media screen and (max-width: $break_sm)
        flex $value
    

flex-grow-sm($value)
    @media screen and (max-width: $break_sm)
        flex-grow $value
    

flex-shrink-sm($value)
    @media screen and (max-width: $break_sm)
        flex-shrink $value
    

flex-basis-sm($value)
    @media screen and (max-width: $break_sm)
        flex-basis $value
    

flex-direction-sm($value)
    @media screen and (max-width: $break_sm)
        flex-direction $value
    

flex-wrap-sm($value)
    @media screen and (max-width: $break_sm)
        flex-wrap $value
    

flex-flow-sm($value)
    @media screen and (max-width: $break_sm)
        flex-flow $value
    

float-sm($value)
    @media screen and (max-width: $break_sm)
        float $value
    

sm($name, $value)
    @media screen and (max-width: $break_sm)
        {$name} $value
    

sm-block(content)
    @media screen and (max-width: $break_sm)
        {content}
    

size-xs($n)
    @media screen and (max-width: $break_xs)
        $value = $atom * $n
        width "calc(%s - %s)" % ($value $offset)
    

col-xs-1()
    size-xs(1)

col-xs-2()
    size-xs(2)

col-xs-3()
    size-xs(3)

col-xs-4()
    size-xs(4)

col-xs-5()
    size-xs(5)

col-xs-6()
    size-xs(6)

col-xs-7()
    size-xs(7)

col-xs-8()
    size-xs(8)

col-xs-9()
    size-xs(9)

col-xs-10()
    size-xs(10)

col-xs-11()
    size-xs(11)

col-xs-12()
    size-xs(12)

offset-xs($n)
    @media screen and (max-width: $break_xs)
        $value = $atom * $n
        margin-left "calc(%s + %s)" % ($value $offset_one_side)
        margin-right "calc(%s + %s)" % ($value $offset_one_side)
    

offset-left-xs($n)
    @media screen and (max-width: $break_xs)
        $value = $atom * $n
        margin-left "calc(%s + %s)" % ($value $offset_one_side)
    

offset-right-xs($n)
    @media screen and (max-width: $break_xs)
        $value = $atom * $n
        margin-right "calc(%s + %s)" % ($value $offset_one_side)
    

offset-padding-xs($n)
    @media screen and (max-width: $break_xs)
        $value = $atom * $n
        padding-left "calc(%s + %s)" % ($value $offset_one_side)
        padding-right "calc(%s + %s)" % ($value $offset_one_side)
    

offset-left-padding-xs($n)
    @media screen and (max-width: $break_xs)
        $value = $atom * $n
        padding-left "calc(%s + %s)" % ($value $offset_one_side)
    

offset-right-padding-xs($n)
    @media screen and (max-width: $break_xs)
        $value = $atom * $n
        padding-right "calc(%s + %s)" % ($value $offset_one_side)
    

justify-content-xs($value)
    @media screen and (max-width: $break_xs)
        justify-content $value
    

align-items-xs($value)
    @media screen and (max-width: $break_xs)
        align-items $value
    

align-content-xs($value)
    @media screen and (max-width: $break_xs)
        align-content $value
    

align-self-xs($value)
    @media screen and (max-width: $break_xs)
        align-self $value
    

order-xs($value)
    @media screen and (max-width: $break_xs)
        order $value
    

flex-xs($value)
    @media screen and (max-width: $break_xs)
        flex $value
    

flex-grow-xs($value)
    @media screen and (max-width: $break_xs)
        flex-grow $value
    

flex-shrink-xs($value)
    @media screen and (max-width: $break_xs)
        flex-shrink $value
    

flex-basis-xs($value)
    @media screen and (max-width: $break_xs)
        flex-basis $value
    

flex-direction-xs($value)
    @media screen and (max-width: $break_xs)
        flex-direction $value
    

flex-wrap-xs($value)
    @media screen and (max-width: $break_xs)
        flex-wrap $value
    

flex-flow-xs($value)
    @media screen and (max-width: $break_xs)
        flex-flow $value
    

float-xs($value)
    @media screen and (max-width: $break_xs)
        float $value
    

xs($name, $value)
    @media screen and (max-width: $break_xs)
        {$name} $value
    

xs-block(content)
    @media screen and (max-width: $break_xs)
        {content}
    

debug($background, $outline)
    height 100vh
    position fixed
    width 100%
    
    > div
        height inherit
        wrapper()
        
        > div
            height inherit
            row-flex()
            
            > div
                col()
                size(1)
                height inherit
                outline $outline
                background $background
            
        
    

clearfix()
    &::after
        display block
        content ""
        clear both
    

